<%
' Other websites that do this sort of thing:
' 	http://www.keywordcount.com/
'	http://www.mytranslate.com/wordfrequency.htm
'	http://www.georgetown.edu/faculty/ballc/webtools/web_freqs_help.html

option explicit

dim strText			' as string
dim bolHideSingleWordInstances	' as boolean
dim intSortBy		' as integer
dim lngI			' as long
const DBUG = false	' Debugging flag

' Do we have a URL?
dim strUrl		' as string
strUrl = lcase ( Request.Form("url") )
if strUrl <> "" and strUrl <> "http://" then
	' If the http:// was overwritten, re-write
	if left ( strUrl, 7 ) <> "http://" then strUrl = "http://" & strUrl

	' Get the page
	strText = pDownloadHtmlPage ( strUrl )

	' For debugging purposes, save the page
	if DBUG then pDumpText strText, Server.MapPath (".") & "\wc_raw.txt"
else
	' Do we have a pasted page?
	dim strPaste	' as string
	strPaste = Request.Form("paste")

	if strPaste <> "" then strText = strPaste
end if

' Did we get anything?
if strText <> "" then

	' Start the result page
	pHtmlHeader

	' Look to the options
	bolHideSingleWordInstances = ( Request("hidesingle") = 1 )
	intSortBy = CInt ( Request("sort") )

	' Any keywords?
	if Request("keywords") <> "" then
		' Parse into an array
		dim arrKeywords		' as array of strings
		arrKeywords = Split ( Request("keywords")," " )
	end if

	' Assume all text is from a webpage for now
	strText = pProcessWebPage ( strText )

	' For debugging purposes, save the page
	if DBUG then pDumpText strText, Server.MapPath (".") & "\wc_processed.txt"

	' Now tokenize on spaces
	Dim  strTokens
	strTokens = Split ( strText, " " )

	dim dicWord		' as dictionary object, a.k.a. associative array
	Set dicWord = CreateObject("Scripting.Dictionary")
	if Err then exception ( "Couldn't create dictionary object" )

	dim lngMaxCountLength	' as long.  Used to store the string length of the count
	dim strKeyword		' as string
	For lngI = 0 To UBound ( strTokens )
		''response.write strTokens ( lngI ) & "<BR>"

		if Request("keywords") <> "" then
			' Is this a keyword?
			for each strKeyword in arrKeywords
				if instr ( 1, strTokens ( lngI ), strKeyword, vbTextCompare ) > 0 then
					strTokens ( lngI ) = "<B>" & strTokens ( lngI ) & "</B>" & vbCrLf
				end if
			next
		end if

		if not dicWord.Exists ( strTokens ( lngI ) ) then 
			' Stuff into array
			''response.write "new " & strTokens ( lngI ) & "<BR>" & vbCrLf
			dicWord.Add strTokens ( lngI ), 1
		else
			''response.write "dup " & strTokens ( lngI )  & "<BR>" & vbCrLf
			dim lngNewCount		' as long
			lngNewCount = dicWord(strTokens(lngI)) + 1
			dicWord( strTokens ( lngI )) = lngNewCount
			if len(lngNewCount) > lngMaxCountLength then lngMaxCountLength = len ( lngNewCount )
		end if
	Next

	if intSortBy = dictItem then
		' Before showing the list, pad the count with zeros because the SortDictionary
		' function does a text compare.
		dim strCurKey			' as string
		dim arrCounts			' as array
		arrCounts = dicWord.Keys
		For each strCurKey in arrCounts
			' Pad with zeros.  The number of zeros has already been determined
			dim strCurCount		' as string
			strCurCount = dicWord(strCurKey)
			for lngI = 1 to lngMaxCountLength - Len( strCurCount )
				strCurCount = "0" & strCurCount
			Next

			' Put it back
			dicWord(strCurKey) = strCurCount
			''response.write strCurCount & "<BR>" & vbCrlf
		Next
	end if

	' Now show the list
	dim arrWords						' as Items array
	dim lngCurWord						' as long
	SortDictionary dicWord, intSortBy	' sort
	arrWords = dicWord.Keys
	response.write "<BR><span class='message'>Unique word count [" & dicWord.Count & "].</span><BR>" & vbCrLf
	if bolHideSingleWordInstances then response.write "<BR><span class='message'>Hiding Single Word Instances</span><BR>" & vbCrLf
	For lngCurWord = 0 To dicWord.Count - 1
		if bolHideSingleWordInstances then
			if dicWord(arrWords(lngCurWord)) > 1 then
				Response.Write arrWords(lngCurWord) & " [" & dicWord(arrWords(lngCurWord)) & "]<BR>" & vbCrLf
			end if
		else
			Response.Write arrWords(lngCurWord) & " [" & dicWord(arrWords(lngCurWord)) & "]<BR>" & vbCrLf
		end if
	Next

	response.write "<BR><BR><a href='wordcount.asp'>Back</a>" & vbCrLf
	response.end
end if

' ------------------- functions / subs ---------------------------------------------------------

function pProcessWebPage ( astrWebPage )
	' cleans up text that is a web page

	' Clear all javascript
	astrWebPage = pClearTagContents ( astrWebPage, "<SCRIPT", "</SCRIPT>" )

	' Clear out style sheet
	astrWebPage = pClearTagContents ( astrWebPage, "<STYLE", "</STYLE>" )

	' Clear out all tags < ... > & </ ... >
	astrWebPage = pClearTags ( astrWebPage )

	' Convert spaces to spaces
	astrWebPage = replace ( astrWebPage, "&nbsp;", " " )

	' This could be cleaned up
	astrWebPage = replace ( astrWebPage, """", "" )
	astrWebPage = replace ( astrWebPage, ";", "" )
	astrWebPage = replace ( astrWebPage, ":", "" )
	astrWebPage = replace ( astrWebPage, ",", "" )
	astrWebPage = replace ( astrWebPage, "?", "" )
	astrWebPage = replace ( astrWebPage, "/", " " )
	astrWebPage = replace ( astrWebPage, "|", " " )
	astrWebPage = replace ( astrWebPage, "&", " " )
	astrWebPage = replace ( astrWebPage, "@ ", " " )
	astrWebPage = replace ( astrWebPage, " @", " " )
	astrWebPage = replace ( astrWebPage, " - ", " " )
	astrWebPage = replace ( astrWebPage, "", " " )			' This is ALT-0151

	astrWebPage = pSpaceRedux ( astrWebPage )

	pProcessWebPage = astrWebPage
end function

function pDownloadHtmlPage ( astrUrl )
	on error resume next

	' Get the page
	Dim objXmlHttp		' as object
	set objXmlHttp = CreateObject("MSXML2.XMLHTTP")
	If Err then exception "Could not create XMLHTTP object. " & Err.Description

	objXmlHttp.open "GET", astrUrl, False
	If Err then exception "Could not open page [" & astrUrl & "]. " & Err.Description
	objXmlHttp.send
	If Err then exception "Could not send. " & Err.Description

	' Here we get Binary data, i.e. two bytes corresponding to each string datum.
	' Need to use 'B' functions like MidB, AscB to manipulate the byte array.
	'
	' More information on working w/ Binary & String manipulation
	' http://www.pstruh.cz/tips/detpg_BinASP.htm
	'
	' ResponseBody property
	' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/xmlsdk30/htm/xmproresponsetextixmlhttprequest.asp
	dim varResponseBody		' as variant
	varResponseBody = objXmlHttp.ResponseBody
	If Err then exception "Could not receive data through ResponseBody property. " & Err.Description
	''response.write "Received [" & LenB ( varResponseBody ) & "] characters for page [" & astrUrl & "] <BR>" & vbCrLf

	' Get the count
	dim lngResponseLength		' as long
	lngResponseLength = LenB ( varResponseBody )
	If Err then exception "Could not get response length. " & Err.Description

	' Loop through each binary character and convert to string
	dim strResponseText		' as string
	for lngI = 1 to lngResponseLength
		''response.write lngI & " " & Chr(AscB(MidB(varResponseBody, lngI, 1 ) ) ) & "<BR>" & vbCrLf
		strResponseText = strResponseText & Chr(AscB(MidB(varResponseBody, lngI, 1 ) ) )
	next
	If Err then exception "Unable to convert binary to string. " & Err.Description

	pDownloadHtmlPage = strResponseText
	on error goto 0
end function

function pClearTags ( astrWebPage )
	on error resume next
	' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/script56/html/vspropattern.asp
	Dim objRegExp			' as object
	Dim objMatch			' as object

	' Ensure something was sent
	if astrWebPage = "" then exception "pClearTags(): Nothing sent"

	Set objRegExp = New RegExp
	If Err then exception "pClearTags(): Could not create RegExp object. " & Err.Description

	With objRegExp
		.Pattern = "<[^>]*>"
		.IgnoreCase = True
		.Global = True					' match occurrences
	End With
	If Err then exception "pClearTags(): Problem setting RegExp parameters. " & Err.Description

	pClearTags = objRegExp.Replace ( astrWebPage, " " )   ' Make replacement.

	Set objMatch = nothing
	Set objRegExp = nothing
	on error goto 0
end function

function pClearTagContents ( astrWebPage, astrStartTag, astrEndTag ) 
	' Clears any of the specified tag with the contents between.
	on error resume next

	dim lngPos				' as long
	dim lngPosEnd			' as long

	dim strResultPage		' as string
	strResultPage = astrWebPage

	dim lngStartTagLength	' as long
	lngStartTagLength = len ( astrStartTag )

	dim lngEndTagLength		' as long
	lngEndTagLength = len ( astrEndTag )

	' This is an escape route in case something goes wrong
	dim lngLoopCount	' as long
	lngLoopCount = 1

	lngPos = Instr ( 1, strResultPage, astrStartTag, vbTextCompare )
	if Err then response.write "pClearTagContents(): Error running Instr ()." & Err.Description : response.end
	''response.write "Initial lngPos [" & lngPos & "]<BR>" & vbCrLf
	do while lngPos > 1
		' Find the end tag
		lngPosEnd = Instr ( lngPos + lngStartTagLength, strResultPage, astrEndTag, vbTextCompare )
		if Err then response.write "pClearTagContents(): Error running Instr ()." & Err.Description : response.end
		if lngPosEnd < 1 then exit do			' End tag not found

		' Clear it
		dim strLeft		' as string
		strLeft = left ( strResultPage, lngPos - 1 )
		if Err then response.write "pClearTagContents(): Error running Left ()." & Err.Description : response.end
		''response.write "Left [" & strLeft & "]<BR>" & vbCrlf		
		dim strRight	' as string
		strRight = right ( strResultPage, len ( strResultPage ) - lngPosEnd - lngEndTagLength + 1 )
		if Err then response.write "pClearTagContents(): Error running Right ()." & Err.Description : response.end
		''response.write "Right [" & strRight & "]<BR>" & vbCrlf

		' Glue 'em back together
		strResultPage = strLeft & strRight

		' Get next tag
		lngPos = Instr ( 1, strResultPage, astrStartTag, vbTextCompare )
		if Err then response.write "pClearTagContents(): Error running Instr ()." & Err.Description : response.end

		' Escape route?
		lngLoopCount = lngLoopCount + 1
		if lngLoopCount > 30 then response.write "pClearTagContents(): Maximum iterations of [30] exceeded.": response.end

	loop

	on error goto 0
	pClearTagContents = strResultPage
end function

function pSpaceRedux ( ByVal astrString )
	' This is a brute force way of converting sequential white space into a single space character.
	' It may be faster to use a RegExp.
	dim strLeft		' as string
	dim strRight	' as string

	' Get rid of multiple spaces
	dim lngLength		' as long
	lngLength = len ( astrString )
	dim lngSpaceStart	' as long
	lngSpaceStart = 0
	Dim intI	' as integer
	For intI = 1 to lngLength
		select case Mid ( astrString, intI, 1 )
			case " ", vbCr, vbLf, vbTab:
				' Start a white space stream?
				if lngSpaceStart = 0 then 
					lngSpaceStart = intI
					'response.write intI & " set" & vbCrlf
				else
					'response.write intI & " space " & vbCrlf
				end if
			case else
				if lngSpaceStart > 0 then
					'response.write intI & " remove" & vbCrlF
					' Time to remove spaces
					strLeft = left ( astrString, lngSpaceStart - 1 )
					'response.write "[" & strLeft & "]"
					strRight = right ( astrString, lngLength - intI + 1 )
					'response.write "[" & strRight & "]" & vbCrLf
					astrString = strLeft & " " & strRight
					lngLength = len ( astrString )
					lngSpaceStart = 0
					intI = len(strLeft) + 1
					'response.write "<HR>"
				end if
		end select
	Next

	pSpaceRedux = astrString
end function

Const dictKey  = 1
Const dictItem = 2

Function SortDictionary ( objDict,aintSortBy )
  ' This function does a text compare sort.
  ' http://support.microsoft.com/default.asplngI?scid=http://support.microsoft.com:80/support/kb/articles/Q246/0/67.asp&NoWebContent=1
  ' declare our variables
  Dim strDict()			' as string array
  Dim objKey			' as object
  Dim strKey,strItem	' as string
  Dim lngJ,lngCount		' as long

  ' get the dictionary count
  lngCount = objDict.Count

  ' we need more than one item to warrant sorting
  If lngCount > 1 Then
    ' create an array to store dictionary information
    ReDim strDict(lngCount,2)

    ' populate the string array.
    lngI = 0
    For Each objKey In objDict
        strDict(lngI,dictKey)  = CStr(objKey)
        strDict(lngI,dictItem) = CStr(objDict(objKey))
        lngI = lngI + 1
    Next

    ' perform a a shell sort of the string array
    For lngI = 0 to (lngCount - 2)
      For lngJ = lngI to (lngCount - 1)
	  	' The order is determined by the < or > sign
		'	< = highest to lowest
		'	> = lowest to highest
        If StrComp ( strDict(lngI,aintSortBy), strDict(lngJ,aintSortBy), vbTextCompare ) > 0 Then
			' Swap
            strKey  = strDict(lngI,dictKey)
            strItem = strDict(lngI,dictItem)
            strDict(lngI,dictKey)  = strDict(lngJ,dictKey)
            strDict(lngI,dictItem) = strDict(lngJ,dictItem)
            strDict(lngJ,dictKey)  = strKey
            strDict(lngJ,dictItem) = strItem
        End If
      Next
    Next

    ' erase the contents of the dictionary object
    objDict.RemoveAll

    ' repopulate the dictionary with the sorted information
    For lngI = 0 to (lngCount - 1)
      objDict.Add strDict(lngI,dictKey), strDict(lngI,dictItem)
    Next

  End If

End Function

function pHtmlHeader
%>
<STYLE type="text/css">	<!--
	TD, P, DIV, LI, BLOCKQUOTE  {
		font-family : Arial, Helvetica, sans-serif;
		font-size : 10pt;
	}
	.message {
		font-size:12pt;
	}
	-->
</STYLE>

<%
end function

Sub pDumpText ( astrText, astrFileName )
	' Dumps the text to a file
	' http://msdn.microsoft.com/library/default.asp?url=/library/en-us/script56/html/jsmthcreatetextfile.asp
	on error resume next

	' Ensure passed arguments
	if astrFileName = "" then exception "pDumpText(): No filename specified"
	if astrText = "" then exit Sub

	Dim FSO					' as file system object
	set FSO = Server.CreateObject("Scripting.FileSystemObject")
	if Err then exception "pDumpText(): Could not create FSO. " & Err.Description

	dim filDumpFile		' as File
	set filDumpFile = FSO.CreateTextFile ( astrFileName, true, false )				' Overwrite := true Unicode := false
	if Err then exception "pDumpText(): Couldn't open file [" & astrFileName & "]. " & Err.Description

	' I tried dumping the straight variable to the text file, but ran
	' into difficulities.  Mostly, it would simply write nothing.  This
	' may be because of the character set . . . I should try again.
	dim arrLines		' as array
	arrLines = Split ( astrText, vbCrLf )
	dim strCurLine		' as string
	for each strCurLine in arrLines
		''response.write strCurLine & vbCrLf
		filDumpFile.WriteLine strCurLine
		if Err then exception "pDumpText(): Couldn't write line [" & strCurLine & "] to file. " & Err.Description
	next

	filDumpFile.Close
	FSO.Close
	set filDumpFile = Nothing
	set FSO = Nothing
	on error goto 0
End Sub


%>
<!-- #include virtual="/inc_style.asp" -->
<!-- #include file="inc_globals.asp" -->

<HTML>
<HEAD>
	<TITLE>Word Count</TITLE>
</HEAD>

<body bgcolor="#FFFFFF" text="black" LINK="blue" VLINK="purple">

<!-- Start content here -->
<% menubar %>

<div align="center">
<table cellspacing="2" cellpadding="2" border="0">
<tr>
    <td align="center">
<strong>Word Count</strong>
<BR><BR>
	</td>
</tr>
<tr>
    <td align="center">
	<form action="wordcount.asp" method="post">
	Enter web address you wish to scan:<BR>
	<input type="text" name="url" value="http://" size="50">
	<BR><BR>
	Or paste the text you wish to tally:<BR>
	<textarea name="paste" cols="40" rows="10"></textarea>
	<BR><BR>
	Enter keywords you want highlighted <span style="font-size:10pt;">(separate with spaces)</span>:<BR>
	<textarea cols="40" rows="4" name="keywords"></textarea>
	<BR><BR>
	<table cellpadding="0" cellspacing="1" bgcolor="Silver">
	<tr>
		<td colspan="2" bgcolor="WhiteSmoke" align="center">Options</td>
	</tr>
	<tr>
		<td bgcolor="White">Hide single word instances:</td>
		<td bgcolor="White"><input type="checkbox" name="hidesingle" value="1" checked></td>
	</tr>
	<tr>
		<td bgcolor="White">Sort:</td>
		<td bgcolor="White">
		<input type="radio" name="sort" value="1"> By word (alphabetical)<BR>
		<input type="radio" name="sort" value="2" checked> By word count<BR>
		</td>
	</tr>
	</table>
	<BR>
	<input type="submit" name="go" value="Go">
	</form>
	</td>
</tr>
</table>
</div>

<!-- End content here -->

</body>
</html>